VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHtml"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Mdulo de clase para exportar controles ListView, Flexgrid, Combo, listbox a HTML

' Autor : Luciano L.E
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


' Declaraciones, UDT, Constantes, Enumeraciones, Variables, Eventos
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Declare Function GetPrivateProfileString _
    Lib "kernel32" _
    Alias "GetPrivateProfileStringA" ( _
    ByVal lpApplicationName As String, _
    ByVal lpKeyName As String, _
    ByVal lpDefault As String, _
    ByVal lpReturnedString As String, _
    ByVal nSize As Long, _
    ByVal lpFileName As String) As Long


Private Declare Function WritePrivateProfileString _
    Lib "kernel32" _
    Alias "WritePrivateProfileStringA" ( _
    ByVal lpApplicationName As String, _
    ByVal lpKeyName As String, _
    ByVal lpString As String, _
    ByVal lpFileName As String) As Long

Private Declare Function GetTempFileName _
    Lib "kernel32" _
    Alias "GetTempFileNameA" ( _
        ByVal lpszPath As String, _
        ByVal lpPrefixString As String, _
        ByVal wUnique As Long, _
        ByVal lpTempFileName As String) As Long

Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_CREATEPROMPT = &H2000
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_EXPLORER = &H80000

Private Declare Function GetFileTitle _
    Lib "comdlg32.dll" _
    Alias "GetFileTitleA" ( _
        ByVal lpszFile As String, _
        ByVal lpszTitle As String, _
        ByVal cbBuf As Integer) As Integer

Private Declare Function CHOOSECOLOR _
    Lib "comdlg32.dll" _
    Alias "ChooseColorA" ( _
        pChoosecolor As CHOOSECOLOR) As Long

Private Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Enum EOptionDialog
    [Normal] = 0
    [Completo] = 2
End Enum
Private Declare Function GetOpenFileName _
    Lib "comdlg32.dll" _
    Alias "GetOpenFileNameA" ( _
    pOpenfilename As OPENFILENAME) As Long

Private Declare Function GetSaveFileName _
    Lib "comdlg32.dll" _
    Alias "GetSaveFileNameA" ( _
    pOpenfilename As OPENFILENAME) As Long

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Declare Function ShellExecute _
    Lib "shell32.dll" _
    Alias "ShellExecuteA" ( _
        ByVal hWnd As Long, _
        ByVal lpOperation As String, _
        ByVal lpFile As String, _
        ByVal lpParameters As String, _
        ByVal lpDirectory As String, _
        ByVal nShowCmd As Long) As Long

Private Const SW_SHOWNORMAL = 1

Private Type BrowseInfo
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type

Private Const BIF_RETURNONLYFSDIRS = 1
Private Const MAX_PATH = 260
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)

Private Declare Function lstrcat _
    Lib "kernel32" _
    Alias "lstrcatA" ( _
        ByVal lpString1 As String, _
        ByVal lpString2 As String) As Long

Private Declare Function SHBrowseForFolder _
    Lib "shell32" ( _
    lpbi As BrowseInfo) As Long

Private Declare Function SHGetPathFromIDList _
    Lib "shell32" ( _
        ByVal pidList As Long, _
        ByVal lpBuffer As String) As Long
Enum eOptionInsertHtml
    [Antes del Header] = 0
    [Despues del Header] = 1
    [Despues del subHeader] = 3
    [Antes del Pie] = 4
    [Despues del Pie] = 5
End Enum

Private Type TInsertHtml
    mOptionInsertHtml                    As eOptionInsertHtml
    mInsertHtml                          As String
End Type

Private arrInsertHtml()                  As TInsertHtml

Public Enum ealign
    [AlignLeft] = 0
    [AlignCenter] = 1
    [AlignRight] = 2
End Enum

Enum eTtypeObject
    [ListView] = 0
    [FlexGrid] = 1
    [ComboBoxListBox] = 2
    [ADODBRecordset] = 3
End Enum

Enum eAction
    [Add] = 0
    [Clear] = 1
End Enum

Private mPictureLogoPath                 As String
Private mPictureLogoAlign                As ealign

Private mTextHeader                      As String
Private mTextSubHeader                   As String

Private mTextFoother                     As String
Private mSizeBorderTable                 As Variant
Private mBorderColorTable                As String
Private mBackGroundColorTable            As String
Private mBackGroundColorHeader           As String
Private mAlignFontColumnHeader           As ealign
Private mAlignFontHeader                 As ealign
Private mFontSizeColumnHeaders           As Variant
Private mFontNameHeader                  As String
Private mFontNameSubHeader               As String
Private mFontColorColumnHeader           As String
Private mBackGroundColorCell             As String
Private mAlignFontCell                   As ealign
Private mFontColorCell                   As String
Private mFontSizeCell                    As Variant
Private mFontNameCell                    As String
Private mBackGroundColorPage             As String
Private mFontSizeHeader                  As Variant
Private mFontSizeSubHeader               As Variant
Private mFontColorHeader                 As String
Private mFontColorSubHeader              As String
Private mFontSizeFoother                 As Variant

Private mPictureBackGroundTable          As String
Private mBackGroundPicturePage           As String
Private mPictureCellItem                 As String

' Colores
'''''''''''''''''''''''''''
Dim color_borde_tabla                    As String
Dim color_fondo_tabla                    As String
Dim color_fondo_encabezado               As String
Dim color_fuente_encabezado              As String
Dim color_fuente_sub_titulo              As String
Dim color_fondo_celda                    As String
Dim color_fuente_celda                   As String
Dim color_fondo_pagina                   As String
Dim color_fuente_titulo                  As String

Dim Align_Encabezado_Col                 As String
Dim Align_Encabezado                     As String
Dim Align_Fuente_celda                   As String

Dim sBackGroundPicTable                  As String
Dim sBackGroundPicturePage               As String
Dim sImgItem                             As String

Private mOutputPath                      As String

Private mUseIniFile                      As Boolean
Private mApplication                     As String
Private mPathIni                         As String


Event Progress(ByVal ValueProgress As Integer)


' Inicio de la clase ( Valores por defecto)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Class_Initialize()
    
    ' esto debe estar siempre alcomienzo de todo
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    mApplication = App.EXEName
    mPathIni = App.Path & "\settingsHtml.ini"

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    mUseIniFile = Leer_Ini("mUseIniFile", "0")
    
    If Not mUseIniFile Then
       If Len(Dir(App.Path & "\settingsHtml.ini")) <> 0 Then
          Kill App.Path & "\settingsHtml.ini"
       End If
    End If
    
    ' texto
    mTextHeader = Leer_Ini("mTextHeader", "")
    mTextSubHeader = Leer_Ini("mTextSubHeader", "")
    mTextFoother = Leer_Ini("mTextFoother", "")
    
    ' tamaos
    mSizeBorderTable = Leer_Ini("mSizeBorderTable", "0")
    mFontSizeHeader = Leer_Ini("mFontSizeHeader", "6")
    mFontSizeSubHeader = Leer_Ini("mFontSizeSubHeader", "3")
    mFontSizeCell = Leer_Ini("mFontSizeCell", "1")
    mFontSizeColumnHeaders = Leer_Ini("mFontSizeColumnHeaders", "2")
    mFontSizeFoother = Leer_Ini("mFontSizeFoother", "2")
    
    ' colores
    mBorderColorTable = Leer_Ini("mBorderColorTable", vbBlack)
    mBackGroundColorTable = Leer_Ini("mBackGroundColorTable", vbWhite)
    mBackGroundColorHeader = Leer_Ini("mBackGroundColorHeader", vbWhite)
    mFontColorColumnHeader = Leer_Ini("mFontColorColumnHeader", vbWhite)
    mBackGroundColorCell = Leer_Ini("mBackGroundColorCell", vbWhite)
    mBackGroundColorPage = Leer_Ini("mBackGroundColorPage", vbWhite)
    
    mFontColorHeader = Leer_Ini("mFontColorHeader", vbBlack)
    mFontColorCell = Leer_Ini("mFontColorCell", vbBlack)
    mFontColorSubHeader = Leer_Ini("mFontColorSubHeader", vbBlack)
    
    ' Alineaciones
    mAlignFontColumnHeader = Leer_Ini("mAlignFontColumnHeader", "0")
    mAlignFontCell = Leer_Ini("mAlignFontCell", "0")
    mAlignFontHeader = Leer_Ini("mAlignFontHeader", "0")
    
    ' fuentes
    mFontNameHeader = Leer_Ini("mFontNameHeader", "verdana")

    mFontNameCell = Leer_Ini("mFontNameCell", "verdana")
     
    mFontNameSubHeader = Leer_Ini("mFontNameSubHeader", "verdana")
    
    ' Pictures
    
    mPictureCellItem = Leer_Ini("mPictureCellItem", "")
    mPictureBackGroundTable = Leer_Ini("mPictureBackGroundTable", "")
    mBackGroundPicturePage = Leer_Ini("mBackGroundPicturePage", "")
    
    ' Path Html
    mOutputPath = Leer_Ini("mOutputPath", "")
    
    ' Otros
    ReDim arrInsertHtml(0)
    
    mPictureLogoPath = Leer_Ini("mPictureLogoPath", "")
    mPictureLogoAlign = Leer_Ini("mPictureLogoAlign ", "1")
    
End Sub


' Propiedades - texto
''''''''''''''''''''''''''''''''''
Property Get TextHeader() As String
    TextHeader = mTextHeader
End Property
Property Let TextHeader(value As String)
    mTextHeader = value
End Property

Property Get TextSubHeader() As String
    TextSubHeader = mTextSubHeader
End Property
Property Let TextSubHeader(value As String)
    mTextSubHeader = value
End Property
Property Get TextFoother() As String
    TextFoother = mTextFoother
End Property
Property Let TextFoother(value As String)
    mTextFoother = value
End Property

' Propiedades - Tamaos
''''''''''''''''''''''''''''''''''

Property Get SizeBorderTable() As Variant
    SizeBorderTable = mSizeBorderTable
End Property
Property Let SizeBorderTable(value As Variant)
    If Not IsNumeric(value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mSizeBorderTable = CStr(value)
    End If
End Property

Property Get FontSizeHeader() As Variant
    FontSizeHeader = mFontSizeHeader
End Property
Property Let FontSizeHeader(value As Variant)
    If Not IsNumeric(value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeHeader = CStr(value)
    End If
End Property

Property Get FontSizeSubHeader() As Variant
    FontSizeSubHeader = mFontSizeSubHeader
End Property
Property Let FontSizeSubHeader(value As Variant)
    If Not IsNumeric(value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeSubHeader = CStr(value)
    End If
End Property


Property Get FontSizeCell() As Variant
    FontSizeCell = mFontSizeCell
End Property

Property Let FontSizeCell(value As Variant)
    If Not IsNumeric(value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeCell = CStr(value)
    End If
End Property

Property Get FontSizeColumnHeaders() As Variant
    FontSizeColumnHeaders = mFontSizeColumnHeaders
End Property
Property Let FontSizeColumnHeaders(value As Variant)
    If Not IsNumeric(value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeColumnHeaders = CStr(value)
    End If
End Property

Property Get FontSizeFoother() As Variant
    FontSizeFoother = mFontSizeFoother
End Property
Property Let FontSizeFoother(value As Variant)
    If Not IsNumeric(value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeFoother = CStr(value)
    End If
End Property


' Propiedades - Alineaciones
''''''''''''''''''''''''''''''''''

Property Get AlignFontHeader() As ealign
    AlignFontHeader = mAlignFontHeader
End Property

Property Let AlignFontHeader(value As ealign)
    mAlignFontHeader = value
End Property


Property Get AlignFontColumnHeader() As ealign
    AlignFontColumnHeader = mAlignFontColumnHeader
End Property

Property Let AlignFontColumnHeader(value As ealign)
    mAlignFontColumnHeader = value
End Property

Property Get AlignFontCell() As ealign
    AlignFontCell = mAlignFontCell
End Property

Property Let AlignFontCell(value As ealign)
    mAlignFontCell = value
End Property

Property Get PictureLogoAlign() As ealign
    PictureLogoAlign = mPictureLogoAlign
End Property

Property Let PictureLogoAlign(value As ealign)
    mPictureLogoAlign = value
End Property



' Propiedades -  Fuentes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Property Get FontNameHeader() As String
    FontNameHeader = mFontNameHeader
End Property
Property Let FontNameHeader(value As String)
    mFontNameHeader = value
End Property

Property Get FontNameSubHeader() As String
    FontNameSubHeader = mFontNameSubHeader
End Property
Property Let FontNameSubHeader(value As String)
    mFontNameSubHeader = value
End Property


Property Get FontNameCell() As String
    FontNameCell = mFontNameCell
End Property
Property Let FontNameCell(value As String)
    mFontNameCell = value
End Property



' Propiedades -  Colores
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Property Get BorderColorTable() As Variant
    BorderColorTable = mBorderColorTable
End Property

Property Let BorderColorTable(value As Variant)
    mBorderColorTable = value
End Property

Property Get BackGroundColorTable() As Variant
    BackGroundColorTable = mBackGroundColorTable
End Property

Property Let BackGroundColorTable(value As Variant)
    mBackGroundColorTable = value
End Property

Property Get BackGroundColorHeader() As Variant
    BackGroundColorHeader = mBackGroundColorHeader
End Property

Property Let BackGroundColorHeader(value As Variant)
    mBackGroundColorHeader = value
End Property

Property Get FontColorColumnHeader() As Variant
    FontColorColumnHeader = mFontColorColumnHeader
End Property

Property Let FontColorColumnHeader(value As Variant)
    mFontColorColumnHeader = value
End Property

Property Get BackGroundColorCell() As Variant
    BackGroundColorCell = mBackGroundColorCell
End Property

Property Let BackGroundColorCell(value As Variant)
    mBackGroundColorCell = value
End Property

Property Get BackGroundColorPage() As Variant
    BackGroundColorPage = mBackGroundColorPage
End Property

Property Let BackGroundColorPage(value As Variant)
    mBackGroundColorPage = value
End Property

Property Get FontColorHeader() As Variant
    FontColorHeader = mFontColorHeader
End Property

Property Let FontColorHeader(value As Variant)
    mFontColorHeader = value
End Property

Property Get FontColorSubHeader() As Variant
    FontColorSubHeader = mFontColorSubHeader
End Property

Property Let FontColorSubHeader(value As Variant)
    mFontColorSubHeader = value
End Property


Property Get FontColorCell() As Variant
    FontColorCell = mFontColorCell
End Property

Property Let FontColorCell(value As Variant)
    mFontColorCell = value
End Property


' Propiedades -  imagenes
''''''''''''''''''''''''''''


Property Get PictureLogoPath() As String
    PictureLogoPath = mPictureLogoPath
End Property

Property Let PictureLogoPath(value As String)
    mPictureLogoPath = value
End Property


Property Get PictureBackGroundTable() As String
    PictureBackGroundTable = mPictureBackGroundTable
End Property

Property Let PictureBackGroundTable(value As String)
    mPictureBackGroundTable = value
End Property

Property Get PictureCellItem() As String
    PictureCellItem = mPictureCellItem
End Property

Property Let PictureCellItem(value As String)
    mPictureCellItem = value
End Property

Property Get BackGroundPicturePage() As String
    BackGroundPicturePage = mBackGroundPicturePage
End Property

Property Let BackGroundPicturePage(value As String)
    mBackGroundPicturePage = value
End Property

' otros
'''''''''''''''''

Property Get OutputPath() As String
    OutputPath = mOutputPath
End Property
Property Let OutputPath(value As String)
    mOutputPath = value
End Property

'Para grabar o no la confiruacin de las propiedades en un archivo ini
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Property Get UseIniFile() As Boolean
    UseIniFile = mUseIniFile
End Property
Property Let UseIniFile(value As Boolean)
    mUseIniFile = value
End Property


'Funciones
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


' devuelve el directorio (path base) del archivo html ( propiedad mOutputPath )
Private Function GetPath(sValue As String) As String
    Dim sTemp As String

    sTemp = Left(sValue, InStrRev(sValue, "\"))
    
    If Right(sTemp, 1) = "\" Then
       sTemp = Left(sTemp, Len(sTemp) - 1)
    End If
    
    GetPath = sTemp & "\"

End Function

' devuelve la extensin de archivo
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function GetExtension( _
    Path As String, _
    Caracter As String) As String
  
    Dim ret As String
  
    ret = Right(Path, Len(Path) - InStrRev(Path, Caracter))
    GetExtension = ret
  
End Function

' Exportar a HTML ( Indicar el Objeto y el tipo )
Function ExportHtml( _
    Objeto As Object, _
    Tipo As eTtypeObject) As Boolean
    
    On Error GoTo error_function
    
    If mOutputPath = "" Then
        MsgBox "No se ha indicado la ruta para generar el archivo html en la propiedad OutputPath", vbExclamation
        Exit Function
    End If
    
    
    ' Eliminar los archivos previos de la carpeta de imagenes
    Call DeleteFileTemp
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    
    
    ' REcuperar el color de los objetos y la alineacin
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Call PrepColors
    Call PrepAlign
            
    ' Exportar
    '''''''''''''''''''''''''''''''''
     
    Dim sSourceHtml As String
    Dim iRow As Long
    Dim iCol As Long
    Dim nFreeFile As Integer


    Screen.MousePointer = vbHourglass
    nFreeFile = FreeFile
    
    ' abrir el archivo
    '''''''''''''''''''''''''''''''''''
    Open mOutputPath For Output As nFreeFile
    
    
    ' CrearPictures
    '''''''''''''''''''''''''''''''''''
    Call CrearPictures(Me.OutputPath)
        
    
    
    ' cabecera de la pgina
    '''''''''''''''''''''''''''''''''''
    sSourceHtml = CrearCabecera(Me.OutputPath)
                   
    Call PrintHtml(sSourceHtml, nFreeFile)
                       
    sSourceHtml = CrearTabla()
    
    ' Exportar
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Select Case Tipo
        
        ' ListView
        '''''''''''''''''''''''''''''''''''''
        Case 0
    
            For iCol = 1 To Objeto.ColumnHeaders.Count
    
                sSourceHtml = sSourceHtml & CrearTH( _
                                                Trim(Objeto.ColumnHeaders(iCol).Text), _
                                                mFontSizeColumnHeaders, _
                                                color_fuente_encabezado, _
                                                mFontNameHeader, _
                                                Align_Encabezado_Col)


            Next

            
            sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
            Call PrintHtml(sSourceHtml, nFreeFile)
    
            For iRow = 1 To Objeto.ListItems.Count
            
                sSourceHtml = sSourceHtml & "<TR bgcolor=" & _
                              color_fondo_celda & " > " & vbCrLf
        
        
        
                sSourceHtml = sSourceHtml & "<td>" & sImgItem & "</td>"
                sSourceHtml = sSourceHtml & " <td><div align=" & _
                                        Align_Fuente_celda & "><font color=" & _
                                        color_fuente_celda & " size=" & _
                                        mFontSizeCell & " face=" & _
                                        mFontNameCell & ">" & _
                                        "&nbsp;&nbsp;" & Objeto.ListItems(iRow).Text & _
                                        "</font></div></td>" & vbCrLf

        
                For iCol = 2 To Objeto.ColumnHeaders.Count

                    sSourceHtml = sSourceHtml & " <td><div align=" & _
                                  Align_Fuente_celda & "><font color=" & _
                                  color_fuente_celda & " size=" & _
                                  mFontSizeCell & " face=" & _
                                  mFontNameCell & ">" & _
                                  Objeto.ListItems(iRow).SubItems(iCol - 1) & _
                                  "</font></div></td>" & vbCrLf

                Next
                sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
                Call PrintHtml(sSourceHtml, nFreeFile)
                Call mRaiseEvent(Objeto.ListItems.Count, iRow)
            Next
        
        ' MsFlexGrid / Hierarchical Flexgrid
        '''''''''''''''''''''''''''''''''''''
        Case 1
        
            For iCol = 0 To Objeto.Cols - 1
            
                sSourceHtml = sSourceHtml & CrearTH( _
                                                Trim(Objeto.TextMatrix(0, iCol)), _
                                                mFontSizeColumnHeaders, _
                                                color_fuente_encabezado, _
                                                mFontNameHeader, _
                                                Align_Encabezado_Col)
            

            Next

            sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
            Call PrintHtml(sSourceHtml, nFreeFile)
            
            For iRow = 1 To Objeto.Rows - 1
            
                sSourceHtml = sSourceHtml & "<TR bgcolor=" & _
                              color_fondo_celda & " > " & vbCrLf
        
        
        
                sSourceHtml = sSourceHtml & "<td>" & sImgItem & "</td>"
                sSourceHtml = sSourceHtml & " <td><div align=" & _
                                        Align_Fuente_celda & "><font color=" & _
                                        color_fuente_celda & " size=" & _
                                        mFontSizeCell & " face=" & _
                                        mFontNameCell & ">" & _
                                        "&nbsp;&nbsp;" & Objeto.TextMatrix(iRow, 0) & _
                                        "</font></div></td>" & vbCrLf

                For iCol = 1 To Objeto.Cols - 1

                    sSourceHtml = sSourceHtml & " <td><div align=" & _
                                  Align_Fuente_celda & "><font color=" & _
                                  color_fuente_celda & " size=" & _
                                  mFontSizeCell & " face=" & _
                                  mFontNameCell & ">" & _
                                  Objeto.TextMatrix(iRow, iCol) & _
                                  "</font></div></td>" & vbCrLf
                    

                Next
                sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
                Call PrintHtml(sSourceHtml, nFreeFile)
                Call mRaiseEvent(Objeto.Rows - 1, iRow)
                
        Next
        
        ' ComboBox ListBox
        '''''''''''''''''''''''''''''''''''''
        
        Case 2
                sSourceHtml = sSourceHtml & CrearTH( _
                                                vbNullString, _
                                                mFontSizeColumnHeaders, _
                                                color_fuente_encabezado, _
                                                mFontNameHeader, _
                                                Align_Encabezado_Col)
                                                            
            sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
            Call PrintHtml(sSourceHtml, nFreeFile)
                                          
            For iRow = 0 To Objeto.ListCount - 1
            
                sSourceHtml = sSourceHtml & "<TR bgcolor=" & _
                              color_fondo_celda & " > " & vbCrLf
        
        
        
                sSourceHtml = sSourceHtml & "<td>" & sImgItem & "</td>"
                sSourceHtml = sSourceHtml & " <td><div align=" & _
                                        Align_Fuente_celda & "><font color=" & _
                                        color_fuente_celda & " size=" & _
                                        mFontSizeCell & " face=" & _
                                        mFontNameCell & ">" & _
                                        "&nbsp;&nbsp;" & Objeto.List(iRow) & _
                                        "</font></div></td>" & "</TR>" & vbCrLf
                                        
                Call PrintHtml(sSourceHtml, nFreeFile)
                Call mRaiseEvent(Objeto.ListCount - 1, iRow)
                                                    
            Next
                    
        ' Adodb - recordset
        '''''''''''''''''''''''''''''''''''''
        Case 3
    
            For iCol = 0 To Objeto.Fields.Count - 1
    
                sSourceHtml = sSourceHtml & CrearTH( _
                                                Trim(Objeto.Fields(iCol).Name), _
                                                mFontSizeColumnHeaders, _
                                                color_fuente_encabezado, _
                                                mFontNameHeader, _
                                                Align_Encabezado_Col)


            Next

            
            sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
            Call PrintHtml(sSourceHtml, nFreeFile)
    
            While Not Objeto.EOF
            
                sSourceHtml = sSourceHtml & "<TR bgcolor=" & _
                              color_fondo_celda & " > " & vbCrLf
        
        
        
                sSourceHtml = sSourceHtml & "<td>" & sImgItem & "</td>"
                sSourceHtml = sSourceHtml & " <td><div align=" & _
                                        Align_Fuente_celda & "><font color=" & _
                                        color_fuente_celda & " size=" & _
                                        mFontSizeCell & " face=" & _
                                        mFontNameCell & ">" & _
                                        "&nbsp;&nbsp;" & Objeto.Fields(0).value & _
                                        "</font></div></td>" & vbCrLf
                                        
                iRow = iRow + 1

        
                For iCol = 1 To Objeto.Fields.Count - 1

                    sSourceHtml = sSourceHtml & " <td><div align=" & _
                                  Align_Fuente_celda & "><font color=" & _
                                  color_fuente_celda & " size=" & _
                                  mFontSizeCell & " face=" & _
                                  mFontNameCell & ">" & _
                                  Objeto.Fields(iCol).value & _
                                  "</font></div></td>" & vbCrLf

                Next
                Objeto.MoveNext
                sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
                Call PrintHtml(sSourceHtml, nFreeFile)
                'Call mRaiseEvent(Objeto.ListItems.Count, iRow)
            Wend
        
        
    End Select
    
    sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
    Call PrintHtml(sSourceHtml, nFreeFile)
    
    sSourceHtml = CrearPie( _
                        mFontSizeFoother, _
                        color_fuente_titulo, _
                        mTextFoother)

    
    ' imprimir el html final y cerrar el archivo
    Call PrintHtml(sSourceHtml, nFreeFile)
    Close #nFreeFile
    
    Screen.MousePointer = vbNormal
    
    ExportHtml = True

' errores
Exit Function

error_function:

    MsgBox Err.Description, vbCritical, "N de error: " & Err.Number
    Screen.MousePointer = vbDefault
    Close
End Function

' funcin que usa la rutina "CrearPictures" para devolver el cdigo html para las imagenes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function getCodePicture( _
    sPath As String, _
    sNamefile As String, _
    sDestino As String)
    
    
    Dim sTempPicture As String
        
    sNamefile = sNamefile & Replace(Timer, ",", "-")
    
    Dim sFinalPathImg As String
    Dim sOutputDirPath As String
    
    sOutputDirPath = GetPath(sDestino)
    
    Dim sNameFolder As String
    
    sNameFolder = GetNameFile(sDestino)
    
    ' path de imagenes
    If Len(Dir(sOutputDirPath & sNameFolder, vbDirectory)) = 0 Then
       MkDir sOutputDirPath & sNameFolder
    End If
    
    If sPath = "" Then
        getCodePicture = ""
        Exit Function
    End If
    
    If Len(Dir(sPath)) = 0 Then
        MsgBox "No se encontr la ruta del archivo: " & sPath, vbCritical, "Error al cargar imagen"
        getCodePicture = ""
    Else
        On Error Resume Next
        sFinalPathImg = sOutputDirPath & sNameFolder & "\" & sNamefile & "." & GetExtension(sPath, ".")
        
        FileCopy sPath, sFinalPathImg
        getCodePicture = sNameFolder & "/" & sNamefile & "." & GetExtension(sPath, ".")
    End If
    
End Function


' Eleimina todos los archivos de la carpeta de imagenes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub DeleteFileTemp()
    
    On Local Error Resume Next

    Dim sFile As String
    Dim sNameFolder As String
    Dim sLocalPath As String
    
    sLocalPath = GetPath(Me.OutputPath)
    sNameFolder = sLocalPath & GetNameFile(Me.OutputPath)
    
    sFile = Dir(sNameFolder & "\*.*")

    While sFile <> ""
        Kill sNameFolder & "\" & sFile
        
        sFile = Dir
    Wend
End Sub

' Vista previa
''''''''''''''''''''''''''
Function Preview() As String
    
    On Error GoTo error_sub
    
    ' preparar los colores de todos los objetos y la alineacin
    Call PrepColors
    Call PrepAlign
            
    ' Exportar
    '''''''''''''''''''''''''''''''''
     
    Dim sSourceHtml As String
    Dim iRow As Long
    Dim iCol As Long
    Dim nFreeFile As Integer

    
    Screen.MousePointer = vbHourglass
    nFreeFile = FreeFile
        
    Dim sTempHtml As String
    
    ' obtener el nombre de archivo temporal
    sTempHtml = getTempFileHtml & ".html"
        
    ' abrir el archivo
    Open sTempHtml For Output As nFreeFile
    
    ' CrearPictures
    Call CrearPictures(sTempHtml)
        
    ' cabecera de la pgina
    '''''''''''''''''''''''''''''''''''
    sSourceHtml = CrearCabecera(sTempHtml)
                   
    Call PrintHtml(sSourceHtml, nFreeFile)
                       
    sSourceHtml = CrearTabla()


        ' Aadir elementos de muestra
        '''''''''''''''''''''''''''''''''''''''''''''''''''''
            For iCol = 0 To 4
            
                sSourceHtml = sSourceHtml & CrearTH( _
                                                "Columna " & iCol, _
                                                mFontSizeColumnHeaders, _
                                                color_fuente_encabezado, _
                                                mFontNameHeader, _
                                                Align_Encabezado_Col)
            

            Next

            sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
            Call PrintHtml(sSourceHtml, nFreeFile)
            
            For iRow = 1 To 10
            
                sSourceHtml = sSourceHtml & "<TR bgcolor=" & _
                              color_fondo_celda & " > " & vbCrLf
        
        
        
                sSourceHtml = sSourceHtml & "<td>" & sImgItem & "</td>"
                sSourceHtml = sSourceHtml & " <td><div align=" & _
                                        Align_Fuente_celda & "><font color=" & _
                                        color_fuente_celda & " size=" & _
                                        mFontSizeCell & " face=" & _
                                        mFontNameCell & ">" & _
                                        "&nbsp;&nbsp;" & "Item: " & iRow & _
                                        "</font></div></td>" & vbCrLf

                For iCol = 1 To 4

                    sSourceHtml = sSourceHtml & " <td><div align=" & _
                                  Align_Fuente_celda & "><font color=" & _
                                  color_fuente_celda & " size=" & _
                                  mFontSizeCell & " face=" & _
                                  mFontNameCell & ">" & _
                                  "SubItem " & iCol & _
                                  "</font></div></td>" & vbCrLf
                    

                Next
                sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
                Call PrintHtml(sSourceHtml, nFreeFile)
        Next
        
    sSourceHtml = CrearPie( _
                        mFontSizeFoother, _
                        color_fuente_titulo, _
                        mTextFoother)

    
    ' imprimir el html final y cerrar el archivo
    Call PrintHtml(sSourceHtml, nFreeFile)
    
    
    
        Close nFreeFile
        Screen.MousePointer = vbNormal
        
        ' retornar el path del fichero temporal
        Preview = sTempHtml
        
        
        
Exit Function

error_sub:
MsgBox Err.Description, vbCritical, "Preview error"
Screen.MousePointer = vbDefault
Close nFreeFile
    
End Function


'Eventos - progreso
'''''''''''''''''''''''''''
Private Sub mRaiseEvent(vMax As Long, vValue As Long)
    RaiseEvent Progress((vValue * 100) / vMax)
End Sub


'Crea el cdigo necesario para la imagen del fondo de la tabla, de la pgina y de la celda
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub CrearPictures(sDestino As String)
    
    ' imagen para el fondo de la tabla
    '''''''''''''''''''''''''''''''''''
    sBackGroundPicTable = ""
    sBackGroundPicturePage = ""
    sImgItem = ""
    
    sBackGroundPicTable = getCodePicture(mPictureBackGroundTable, "PictureBackGroundTable", sDestino)
    If sBackGroundPicTable <> "" Then
       sBackGroundPicTable = "background=" & sBackGroundPicTable
       color_fondo_tabla = ""
       color_fondo_celda = ""
    End If
    ' imagen para el fondo de la pgina
    '''''''''''''''''''''''''''''''''''
    sBackGroundPicturePage = getCodePicture(mBackGroundPicturePage, "BackGroundPicturePage", sDestino)
    If sBackGroundPicturePage <> "" Then
       sBackGroundPicturePage = " background=" & sBackGroundPicturePage
       color_fondo_pagina = ""
    End If
    
    ' imagen para la imagen de 16 x 16 de las celdas
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    sImgItem = getCodePicture(mPictureCellItem, "item", sDestino)
    If sImgItem <> "" Then
       sImgItem = "<img src=" & sImgItem & " width=16 height=16 align=absmiddle>"
    End If

End Sub

' crea la tabla con los atributos
Private Function CrearTabla() As String
    
    Dim sTemp As String
    
    sTemp = "<TABLE width=100% " & sBackGroundPicTable & " BORDER=" & mSizeBorderTable & _
            " Bordercolor=" & color_borde_tabla & " bgcolor=" & color_fondo_tabla & ">" & vbCrLf
    
    CrearTabla = sTemp & "<TR bgcolor=" & color_fondo_encabezado & "> " & vbCrLf & " <TH width=16px>" & "</TH>" & vbCrLf
    
End Function

' crea el Pie de pgina y los insertHtml de pgina
Private Function CrearPie( _
    ByVal mFontSizeFoother As String, _
    ByVal color_fuente_titulo As String, _
    ByVal mTextFoother As String) As String
    
    Dim sTemp As String

    sTemp = "</table>" & vbCrLf
    
    sTemp = sTemp & "<BR>" & chekInsertHtml([Antes del Pie])
    
    sTemp = sTemp & "<HR><font face=verdana size=" & mFontSizeFoother & _
            " color=" & color_fuente_titulo & ">" & _
            mTextFoother & "</font>" & "<P>"
            
    sTemp = sTemp & chekInsertHtml([Despues del Pie])
                  
    CrearPie = sTemp & "</BODY><HEAD><META HTTP-EQUIV=PRAGMA CONTENT=NO-CACHE></HEAD></HTML>"
End Function

'Crear la cabecera y los Insert Html de cabecera
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function CrearCabecera(ByVal sPathHtml As String) As String
    
    Dim sTemp As String
    
    sTemp = "<HTML><HEAD></HEAD>"
    sTemp = sTemp & "<BODY " & sBackGroundPicturePage & " BGCOLOR=" & color_fondo_pagina & ">" & vbCrLf
    
    If mPictureLogoPath <> "" Then
        
        Dim sAlign As String
        
        Select Case mPictureLogoAlign
            Case 0: sAlign = "left"
            Case 1: sAlign = "center"
            Case 2: sAlign = "right"
        End Select
        
        Dim sNameFolder As String
        Dim sFinalPathImg As String
        Dim sOutputDirPath As String
        
        
        sOutputDirPath = GetPath(sPathHtml)
        
        sNameFolder = GetNameFile(sPathHtml)
        
        Dim sLogo As String
        
        sLogo = "logo" & Replace(Timer, ",", "-")
        sFinalPathImg = sOutputDirPath & sNameFolder & "\" & sLogo & "." & GetExtension(mPictureLogoPath, ".")
                        
        If mPictureLogoPath <> "" Then
           If Len(Dir(mPictureLogoPath)) <> 0 Then
              Call FileCopy(mPictureLogoPath, sFinalPathImg)
              sTemp = sTemp & "<p align=" & sAlign & "><img src=" & sNameFolder & "/" & sLogo & "." & GetExtension(mPictureLogoPath, ".") & "></p>"
           Else
              MsgBox "No se ha encontrado el archivo para el logo " & mPictureLogoPath, vbCritical
           End If
        End If
        
    End If
    
    sTemp = sTemp & chekInsertHtml([Antes del Header])
    
    sTemp = sTemp & "<p align=" & Align_Encabezado & "><font face=" & mFontNameHeader & " size=" & mFontSizeHeader & " color=" & color_fuente_titulo & ">" & mTextHeader & "</font></p><HR>"
                                
    sTemp = sTemp & chekInsertHtml([Despues del Header])
                                
    sTemp = sTemp & "<p><font face=" & mFontNameSubHeader & " size=" & mFontSizeSubHeader
    sTemp = sTemp & " color=" & color_fuente_sub_titulo & ">" & mTextSubHeader & "</font></p><HR>"
    
    sTemp = sTemp & chekInsertHtml([Despues del subHeader])
    
    CrearCabecera = sTemp
    
End Function

' Devuelve los cdigos Html insertados, si no hay retorna un vbnullstring
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function chekInsertHtml( _
    OptionHtml As eOptionInsertHtml) As String
    
    Dim i As Integer
    
    For i = 1 To UBound(arrInsertHtml)
       If arrInsertHtml(i).mOptionInsertHtml = OptionHtml Then
          chekInsertHtml = arrInsertHtml(i).mInsertHtml
          Exit For
       End If
    Next
End Function

' Crear los headers
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function CrearTH( _
    ByVal sValue As String, _
    ByVal sFonSizeHeader As String, _
    ByVal sFontColor As String, _
    ByVal SFontNameHeader As String, _
    ByVal sAlignHEader As String) As String
    
    
    CrearTH = " <TH><div align=" & sAlignHEader & ">" & _
              "<font size=" & sFonSizeHeader & _
              " face=" & SFontNameHeader & _
              " color=" & sFontColor & ">" & sValue & _
              "</font></div></TH>" & vbCrLf
    
End Function

' devuelve el color ( si se pasa un long, se convierte, si se pasa un Html Hex se deja igual )
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function getColor(sColorValue As String) As String
    
    If Trim(sColorValue) = "" Then
       getColor = ""
       Exit Function
    End If
    
    If InStr(sColorValue, "#") = 0 Then
       getColor = Me.GetHexadecimalFromRgb(sColorValue)
    Else
       getColor = sColorValue
    End If
End Function

' imprime el Html en el fichero abierto
'''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub PrintHtml(ByRef value As String, NFile As Integer)
    Print #NFile, value
    value = vbNullString
End Sub

' asigna en el array los html insertados, o los crea si no existe
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Sub InsertHtml( _
    sValueHtml As String, _
    OpTionInsert As eOptionInsertHtml)
    
    
    Dim i As Integer
    Dim lindex As Integer
    
    lindex = UBound(arrInsertHtml) + 1
    
    For i = 1 To UBound(arrInsertHtml)
        If arrInsertHtml(i).mOptionInsertHtml = OpTionInsert Then
           arrInsertHtml(i).mInsertHtml = sValueHtml
           Exit Sub
        End If
    Next
    
    ReDim Preserve arrInsertHtml(lindex)
    
    arrInsertHtml(lindex).mInsertHtml = sValueHtml
    arrInsertHtml(lindex).mOptionInsertHtml = OpTionInsert
        
End Sub


' devuelve solo el nombre del archivo html sin la extensin. ese nombre se usa pra crear la carpeta de imagenes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function GetNameFile(ByVal sPath As String) As String
  
    Dim sTemp As String
    Dim sNamefile As String
    Dim Buffer As String
    Buffer = String(255, 0)
    GetFileTitle sPath, Buffer, Len(Buffer)
    sTemp = Left$(Buffer, InStr(1, Buffer, Chr$(0)) - 1)
    
    Dim i As Integer
           
    For i = 1 To Len(sTemp)
        If Mid(sTemp, i, 1) <> "." Then
           sNamefile = sNamefile & Mid(sTemp, i, 1)
        Else
           Exit For
        End If
    Next
               
    GetNameFile = sNamefile
               
End Function

' rertorna un string con el cdigo Hex Html a partir de un long
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetHexadecimalFromRgb(ByVal Color As Long) As String

    Dim Azul As Byte, Verde As Byte, Rojo As Byte
    Dim sRojo As String, sVerde As String, sAzul As String

    Azul = (Color And 16711680) / 65536
    Verde = (Color And 65280) / 256
    Rojo = Color And 255

    If Len(Hex$(Azul)) = 1 Then
        sAzul = "0" & Hex$(Azul)
    Else
        sAzul = Hex$(Azul)
    End If

    If Len(Hex$(Verde)) = 1 Then
        sVerde = "0" & Hex$(Verde)
    Else
        sVerde = Hex$(Verde)
    End If

    If Len(Hex$(Rojo)) = 1 Then
        sRojo = "0" & Hex$(Rojo)
    Else
        sRojo = Hex$(Rojo)
    End If
    
    GetHexadecimalFromRgb = "#" & sRojo & sVerde & sAzul
End Function

' abre un fciehro con el programa asociado
''''''''''''''''''''''''''''''''''''''''''''''''''
Function OpenFile(SpathFile As String) As Boolean
        
    OpenFile = ShellExecute(0, vbNullString, _
                            SpathFile, _
                            vbNullString, _
                            vbNullString, _
                            SW_SHOWNORMAL)
End Function

' dilogo buscar carpeta
''''''''''''''''''''''''''''''''''''''''''''''''''
Function BrowseForFolder() As String

    Dim Nulo As Integer
    Dim Id_List As Long
    Dim El_Path As String
    Dim t_Explorar_dir As BrowseInfo
  
    With t_Explorar_dir
        .hwndOwner = 0
        .lpszTitle = lstrcat("Seleccione un directorio", vbNullString)
        .ulFlags = BIF_RETURNONLYFSDIRS
    End With
  
    Id_List = SHBrowseForFolder(t_Explorar_dir)
  
    If Id_List Then
           
        El_Path = String$(MAX_PATH, 0)
        Call SHGetPathFromIDList(Id_List, El_Path)
        Call CoTaskMemFree(Id_List)
        
        Nulo = InStr(El_Path, vbNullChar)
  
        If Nulo Then
            El_Path = Left$(El_Path, Nulo - 1)
        End If
    End If
       
    BrowseForFolder = El_Path
End Function


' Abre el dilogo de windows para seleccionar color
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function ShowCommonDialogoColor(Optional OptionDialog As EOptionDialog = Normal) As Long

    Dim CustomColors() As Byte
    Dim cc As CHOOSECOLOR
    Dim Custcolor(16) As Long
    Dim lReturn As Long
  
    With cc
        .lStructSize = Len(cc)
        .hwndOwner = 0
        .hInstance = App.hInstance
        .lpCustColors = StrConv(CustomColors, vbUnicode)
    
        If OptionDialog = Completo Then
            .flags = 2
        Else
            .flags = 0
        End If
    End With
    If CHOOSECOLOR(cc) <> 0 Then
        ShowCommonDialogoColor = cc.rgbResult
        CustomColors = StrConv(cc.lpCustColors, vbFromUnicode)
    Else
        ShowCommonDialogoColor = -1
    End If
End Function
  
' Abre el dilogo de windows para seleccionar un archivo
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function ShowOpenFileDialog( _
    Optional sfilter As String, _
    Optional sTitle As String = "seleccionar archivo", _
    Optional sInitialDir As String = "") As String

Dim OFName As OPENFILENAME
Static sPath As String

    With OFName
        .lStructSize = Len(OFName)

        .hwndOwner = 0
        .hInstance = App.hInstance
        
        If Trim(sfilter) = vbNullString Then
           .lpstrFilter = "Todos los archivos (*.*)" + Chr$(0) + "*.*" + Chr$(0)
        Else
           .lpstrFilter = sfilter
        End If
         
        .lpstrFile = Space$(254)
        .nMaxFile = 255
        .lpstrFileTitle = Space$(254)
        .nMaxFileTitle = 255
        .lpstrInitialDir = sInitialDir
        
        .lpstrTitle = sTitle
        .flags = 0
    End With
    
    If GetOpenFileName(OFName) Then
        ShowOpenFileDialog = Trim$(Replace(OFName.lpstrFile, Chr(0), vbNullString))
    Else
        ShowOpenFileDialog = vbNullString
    End If
End Function

' Abre el dilogo de windows para guardar archivo
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function ShowSaveFileDialog( _
    sExtensiones As String, _
    Optional sTitle As String = "Guardar archivo", _
    Optional FilterIndex As Long = 0) As String
    
    On Local Error Resume Next

    Dim ofn As OPENFILENAME
    Dim a As Long
    Dim FileName As String
    
    ofn.lStructSize = Len(ofn)
    ofn.hwndOwner = 0
    ofn.hInstance = App.hInstance
    
    If VBA.Right$(sExtensiones, 1) <> "|" Then sExtensiones = sExtensiones + "|"
    
    For a = 1 To Len(sExtensiones)
        If Mid(sExtensiones, a, 1) = "|" Then Mid(sExtensiones, a, 1) = Chr(0)
    Next
    
    ofn.lpstrFilter = sExtensiones
    ofn.lpstrFile = Space(254)
    ofn.nMaxFile = 255
    ofn.lpstrFileTitle = Space(254)
    ofn.nMaxFileTitle = 255
    ofn.lpstrInitialDir = ""
    If Not FileName = vbNullString Then ofn.lpstrFile = FileName & Space(254 - Len(FileName))
    ofn.nFilterIndex = FilterIndex
    ofn.lpstrTitle = sTitle
    ofn.flags = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT Or OFN_CREATEPROMPT Or OFN_EXPLORER
    
    a = GetSaveFileName(ofn)

    If a Then
       ShowSaveFileDialog = Trim$(ofn.lpstrFile)
       If VBA.Right$(Trim$(ShowSaveFileDialog), 1) = Chr(0) Then ShowSaveFileDialog = VBA.Left$(Trim$(ofn.lpstrFile), Len(Trim$(ofn.lpstrFile)) - 1) & GetExtFilter(ofn.lpstrFilter, ofn.nFilterIndex)
    Else
       ShowSaveFileDialog = vbNullString
    End If
End Function

'Extrae la extension seleccionada del filtro:
Private Function GetExtFilter(sfilter As String, pos As Long) As String
    Dim Ext() As String
    
    Ext = Split(sfilter, vbNullChar)
    
    If pos = 1 And Ext(pos) <> "*.*" Then
        GetExtFilter = "." & Replace(Ext(pos), "*.", "")
        Exit Function
    End If
    If pos = 1 And Ext(pos) = "*.*" Then
        GetExtFilter = vbNullString
        Exit Function
    End If
    If InStr(Ext(pos + 1), "*.*") Then
       GetExtFilter = vbNullString
    Else
       GetExtFilter = "." & Replace(Ext(pos + 1), "*.", "")
    End If
End Function


' recupera los colores
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub PrepColors()
    color_borde_tabla = getColor(mBorderColorTable)
    color_fondo_tabla = getColor(mBackGroundColorTable)
    color_fondo_encabezado = getColor(mBackGroundColorHeader)
    color_fuente_encabezado = getColor(mFontColorColumnHeader)
    color_fondo_celda = getColor(mBackGroundColorCell)
    color_fuente_celda = getColor(mFontColorCell)
    color_fondo_pagina = getColor(mBackGroundColorPage)
    color_fuente_titulo = getColor(mFontColorHeader)
    color_fuente_sub_titulo = getColor(mFontColorSubHeader)
End Sub


' Alineaciones
'''''''''''''''''''''
Private Sub PrepAlign()

    Select Case mAlignFontColumnHeader
        Case 0: Align_Encabezado_Col = "Left"
        Case 1: Align_Encabezado_Col = "Center"
        Case 2: Align_Encabezado_Col = "Right"
        
    End Select
    
    Select Case mAlignFontCell
        Case 0: Align_Fuente_celda = "Left"
        Case 1: Align_Fuente_celda = "Center"
        Case 2: Align_Fuente_celda = "Right"
    End Select
    
    Select Case mAlignFontHeader
        Case 0: Align_Encabezado = "Left"
        Case 1: Align_Encabezado = "Center"
        Case 2: Align_Encabezado = "Right"
    End Select
    
End Sub

' Devuelve un nombre de archivo para crear el temporal para la vista previa
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function getTempFileHtml() As String
    Dim sTemp As String
    Dim ret As Long
    
    sTemp = String(260, 0)
    ret = GetTempFileName(Environ("temp"), "TTT", 0, sTemp)
    getTempFileHtml = Left$(sTemp, InStr(1, sTemp, Chr$(0)) - 1)
  
End Function

Private Function Leer_Ini( _
    Key As String, _
    Default As Variant) As String

Dim bufer As String * 256
Dim Len_Value As Long

        Len_Value = GetPrivateProfileString(mApplication, _
                                         Key, _
                                         Default, _
                                         bufer, _
                                         Len(bufer), _
                                         mPathIni)
        
        Leer_Ini = Left$(bufer, Len_Value)

End Function

Private Function Grabar_Ini( _
    Key As String, _
    Valor As Variant) As String

    WritePrivateProfileString mApplication, Key, Valor, mPathIni
End Function

Private Sub Class_Terminate()
    If mUseIniFile Then
       
       Call Grabar_Ini("mTextHeader", mTextHeader)
       Call Grabar_Ini("mTextSubHeader", mTextSubHeader)
       Call Grabar_Ini("mTextFoother", mTextFoother)
       Call Grabar_Ini("mSizeBorderTable", mSizeBorderTable)
       Call Grabar_Ini("mFontSizeHeader", mFontSizeHeader)
       Call Grabar_Ini("mFontSizeSubHeader", mFontSizeSubHeader)
       Call Grabar_Ini("mFontSizeCell", mFontSizeCell)
       Call Grabar_Ini("mFontSizeColumnHeaders", mFontSizeColumnHeaders)
       Call Grabar_Ini("mFontSizeFoother", mFontSizeFoother)
       Call Grabar_Ini("mBorderColorTable", mBorderColorTable)
       Call Grabar_Ini("mBackGroundColorTable", mBackGroundColorTable)
       Call Grabar_Ini("mBackGroundColorHeader", mBackGroundColorHeader)
       Call Grabar_Ini("mFontColorColumnHeader", mFontColorColumnHeader)
       Call Grabar_Ini("mBackGroundColorCell", mBackGroundColorCell)
       Call Grabar_Ini("mBackGroundColorPage", mBackGroundColorPage)
       Call Grabar_Ini("mFontColorHeader", mFontColorHeader)
       Call Grabar_Ini("mFontColorCell", mFontColorCell)
       Call Grabar_Ini("mFontColorSubHeader", mFontColorSubHeader)
       Call Grabar_Ini("mAlignFontColumnHeader", mAlignFontColumnHeader)
       Call Grabar_Ini("mAlignFontCell", mAlignFontCell)
       Call Grabar_Ini("mFontNameHeader", mFontNameHeader)
       Call Grabar_Ini("mFontNameCell", mFontNameCell)
       Call Grabar_Ini("mFontNameSubHeader", mFontNameSubHeader)
       Call Grabar_Ini("mPictureCellItem", mPictureCellItem)
       Call Grabar_Ini("mPictureBackGroundTable", mPictureBackGroundTable)
       Call Grabar_Ini("mBackGroundPicturePage", mBackGroundPicturePage)
       Call Grabar_Ini("mOutputPath", mOutputPath)
       Call Grabar_Ini("mPictureLogoPath", mPictureLogoPath)
       Call Grabar_Ini("mPictureLogoAlign", mPictureLogoAlign)
       Call Grabar_Ini("mAlignFontHeader", mAlignFontHeader)
    End If
    
    Call Grabar_Ini("mUseIniFile", mUseIniFile)
    
End Sub
